(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ng-circle-timer', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ng-circle-timer"] = {}, global.ng.core, global.rxjs, global.rxjs.operators));
})(this, (function (exports, i0, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var NgCircleTimerService = /** @class */ (function () {
        function NgCircleTimerService() {
        }
        return NgCircleTimerService;
    }());
    NgCircleTimerService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgCircleTimerService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var NgCircleTimerComponent = /** @class */ (function () {
        function NgCircleTimerComponent() {
            this.duration = 0; // milliseconds
            this.color = '#1cbbf8';
            this.onComplete = new i0.EventEmitter();
            this.destroy$ = new rxjs.Subject();
            this.timeLeft = 0;
            this.ticking = false;
            this.completed = false;
            this.formattedTimeLeft = '';
            this.fullDasharray = 283;
            this.dasharray = this.fullDasharray + " " + this.fullDasharray;
        }
        NgCircleTimerComponent.prototype.ngOnInit = function () {
            this.init(this.startDate);
        };
        NgCircleTimerComponent.prototype.ngOnDestroy = function () {
            this.destroy$.next();
            this.destroy$.complete();
        };
        NgCircleTimerComponent.prototype.init = function (startDate) {
            this.setTimeLeft(startDate);
            this.formatTimeLeft();
            this.setDasharray();
            if (this.timeLeft === 0) {
                this.completed = true;
            }
        };
        NgCircleTimerComponent.prototype.setTimeLeft = function (startDate) {
            this.ticking = false;
            this.completed = false;
            this.destroy$.next();
            if (!startDate) {
                this.timeLeft = this.duration;
                return 0;
            }
            var startTime = new Date(startDate).getTime();
            var endTime = startTime + this.duration;
            var timeLeftRaw = endTime - Date.now();
            if (timeLeftRaw <= 0) {
                this.timeLeft = 0;
                return 0;
            }
            var timeLeftSeconds = timeLeftRaw / 1000;
            this.timeLeft = Math.floor(timeLeftSeconds) * 1000;
            return timeLeftSeconds % 1;
        };
        NgCircleTimerComponent.prototype.start = function (startDate, delayMs, replaying) {
            var _this = this;
            if (delayMs === void 0) { delayMs = 0; }
            if (replaying === void 0) { replaying = false; }
            if (this.ticking) {
                console.log('Cannot start: timer already running.');
                return;
            }
            var decimalPortion = this.setTimeLeft(startDate);
            var startDelayMs = delayMs + decimalPortion * 1000;
            this.formatTimeLeft();
            this.setDasharray();
            if (this.timeLeft === 0) {
                this.completed = true;
                console.log('Cannot start: timer already completed.');
                return;
            }
            rxjs.timer(startDelayMs, 1000)
                .pipe(operators.takeUntil(this.destroy$))
                .subscribe(function () {
                _this.ticking = true;
                _this.timeLeft -= 1000;
                if (_this.timeLeft <= 0) {
                    _this.timeLeft = 0;
                    _this.ticking = false;
                    _this.completed = true;
                    _this.onComplete.emit(replaying);
                    _this.destroy$.next();
                }
                _this.formatTimeLeft();
                _this.setDasharray();
            });
        };
        NgCircleTimerComponent.prototype.replay = function (startDate) {
            this.start(startDate, 1200, true);
        };
        NgCircleTimerComponent.prototype.pause = function () { };
        NgCircleTimerComponent.prototype.continue = function () { };
        NgCircleTimerComponent.prototype.complete = function () {
            this.timeLeft = 0;
            this.ticking = false;
            this.completed = true;
            this.destroy$.next();
            this.formatTimeLeft();
            this.setDasharray();
        };
        NgCircleTimerComponent.prototype.isTicking = function () {
            return this.ticking;
        };
        NgCircleTimerComponent.prototype.isCompleted = function () {
            return this.completed;
        };
        NgCircleTimerComponent.prototype.formatTimeLeft = function () {
            if (this.timeLeft <= 0) {
                this.timeLeft = 0;
            }
            var daysLeft = Math.floor(this.timeLeft / (1000 * 60 * 60 * 24));
            var hoursLeft = Math.floor((this.timeLeft % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            var minutesLeft = Math.floor((this.timeLeft % (1000 * 60 * 60)) / (1000 * 60));
            var secondsLeft = Math.floor((this.timeLeft % (1000 * 60)) / 1000);
            var formattedDays = daysLeft < 10 ? "0" + daysLeft : "" + daysLeft;
            var formattedHours = hoursLeft < 10 ? "0" + hoursLeft : "" + hoursLeft;
            var formattedMinutes = minutesLeft < 10 ? "0" + minutesLeft : "" + minutesLeft;
            var formattedSeconds = secondsLeft < 10 ? "0" + secondsLeft : "" + secondsLeft;
            this.formattedTimeLeft = formattedMinutes + ":" + formattedSeconds;
            if (formattedHours !== '00' || formattedDays !== '00') {
                this.formattedTimeLeft = formattedHours + ":" + this.formattedTimeLeft;
            }
            if (formattedDays !== '00') {
                this.formattedTimeLeft = formattedDays + ":" + this.formattedTimeLeft;
            }
        };
        NgCircleTimerComponent.prototype.setDasharray = function () {
            var rawFraction = this.timeLeft / this.duration;
            var fraction = rawFraction - (1 / this.duration) * (1 - rawFraction);
            var remaining = Math.round(fraction * this.fullDasharray);
            this.dasharray = remaining + " " + this.fullDasharray;
        };
        return NgCircleTimerComponent;
    }());
    NgCircleTimerComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgCircleTimerComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: NgCircleTimerComponent, selector: "ng-circle-timer", inputs: { startDate: "startDate", duration: "duration", color: "color" }, outputs: { onComplete: "onComplete" }, ngImport: i0__namespace, template: "\n    <div class=\"base-timer\">\n      <svg class=\"base-timer-svg\"\n           viewBox=\"0 0 100 100\"\n           xmlns=\"http://www.w3.org/2000/svg\">\n        <g class=\"base-timer-circle\">\n          <circle [class.base-timer-completed]=completed [class.base-timer-stroke]=!completed\n                  cx=\"50\"\n                  cy=\"50\"\n                  r=\"45\" />\n          <path [attr.stroke-dasharray]=\"dasharray\"\n                [style.stroke]=\"color\"\n                id=\"remaining-time-stroke\"\n                d=\" M 50, 50\n                m -45, 0\n                a 45,45 0 1,0 90,0\n                a 45,45 0 1,0 -90,0\">\n          </path>\n        </g>\n      </svg>\n      <span class=\"time\">\n    <span>{{formattedTimeLeft}}</span>\n  </span>\n    </div>\n  ", isInline: true, styles: [":host {\n      .base-timer {\n        position: relative;\n        height: 200px;\n        width: 200px;\n\n        &-circle {\n          fill: none;\n          stroke: none;\n        }\n\n        &-stroke {\n          stroke-width: 1px;\n          stroke: grey;\n        }\n\n        &-completed {\n        // stroke-width: 2px;\n        // stroke: #88b462;\n\n          stroke-width: 1px;\n          stroke: grey;\n        }\n\n        .time {\n          position: absolute;\n          width: 200px;\n          height: 200px;\n          top: 0;\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          font-size: 26px;\n\n          img {\n            height: 80px;\n          }\n        }\n\n        #remaining-time-stroke {\n          stroke-width: 2px;\n          transform: rotate(90deg);\n          transform-origin: center;\n          transition: 1s linear all;\n          stroke: #1cbbf8;\n        }\n\n        .base-timer-svg {\n          transform: scaleX(-1);\n        }\n      }\n    }\n    "] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ng-circle-timer',
                        template: "\n    <div class=\"base-timer\">\n      <svg class=\"base-timer-svg\"\n           viewBox=\"0 0 100 100\"\n           xmlns=\"http://www.w3.org/2000/svg\">\n        <g class=\"base-timer-circle\">\n          <circle [class.base-timer-completed]=completed [class.base-timer-stroke]=!completed\n                  cx=\"50\"\n                  cy=\"50\"\n                  r=\"45\" />\n          <path [attr.stroke-dasharray]=\"dasharray\"\n                [style.stroke]=\"color\"\n                id=\"remaining-time-stroke\"\n                d=\" M 50, 50\n                m -45, 0\n                a 45,45 0 1,0 90,0\n                a 45,45 0 1,0 -90,0\">\n          </path>\n        </g>\n      </svg>\n      <span class=\"time\">\n    <span>{{formattedTimeLeft}}</span>\n  </span>\n    </div>\n  ",
                        styles: [
                            ":host {\n      .base-timer {\n        position: relative;\n        height: 200px;\n        width: 200px;\n\n        &-circle {\n          fill: none;\n          stroke: none;\n        }\n\n        &-stroke {\n          stroke-width: 1px;\n          stroke: grey;\n        }\n\n        &-completed {\n        // stroke-width: 2px;\n        // stroke: #88b462;\n\n          stroke-width: 1px;\n          stroke: grey;\n        }\n\n        .time {\n          position: absolute;\n          width: 200px;\n          height: 200px;\n          top: 0;\n          display: flex;\n          align-items: center;\n          justify-content: center;\n          font-size: 26px;\n\n          img {\n            height: 80px;\n          }\n        }\n\n        #remaining-time-stroke {\n          stroke-width: 2px;\n          transform: rotate(90deg);\n          transform-origin: center;\n          transition: 1s linear all;\n          stroke: #1cbbf8;\n        }\n\n        .base-timer-svg {\n          transform: scaleX(-1);\n        }\n      }\n    }\n    "
                        ]
                    }]
            }], ctorParameters: function () { return []; }, propDecorators: { startDate: [{
                    type: i0.Input
                }], duration: [{
                    type: i0.Input
                }], color: [{
                    type: i0.Input
                }], onComplete: [{
                    type: i0.Output
                }] } });

    var NgCircleTimerModule = /** @class */ (function () {
        function NgCircleTimerModule() {
        }
        return NgCircleTimerModule;
    }());
    NgCircleTimerModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgCircleTimerModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerModule, declarations: [NgCircleTimerComponent], exports: [NgCircleTimerComponent] });
    NgCircleTimerModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: NgCircleTimerModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            NgCircleTimerComponent
                        ],
                        imports: [],
                        exports: [
                            NgCircleTimerComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of ng-circle-timer
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgCircleTimerComponent = NgCircleTimerComponent;
    exports.NgCircleTimerModule = NgCircleTimerModule;
    exports.NgCircleTimerService = NgCircleTimerService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-circle-timer.umd.js.map
